program ritterspiel;
uses crt,graph4,graph;
type zeiger=^ritter;
    ritter=record name  : string;
                  quote : integer;
                  next  : zeiger;
    end;

const
      egavgaPath: string='';
      pi     : real = 3.1415927;
      anzahl : integer = 8;
      namen  : array[1..12] of string=(
      'Richard','Eduart','Shakespear','Napoleon','Alf','Charles',
      'Theodor','Arthus','Carlos','Thor','Lanzelott','Rbennase');

var ring:zeiger;
    knight:picture;
    gd,gm,ec:integer;

function anz:byte;
var first:zeiger;
    a:byte;
    z:zeiger;
begin
z:=ring;
a:=1;
z:=z^.next;
repeat
a:=a+1;
z:=z^.next;
until z=ring;
anz:=a;
end;

procedure show(focus:zeiger);
var first:zeiger;
    z:zeiger;
    player:byte;
    winkel:real;
    x,y:integer;
begin
clearviewport;
loadpicture(addr(knight),'knight.pic');
z:=ring;
player:=1;
textcolor(15);
repeat
winkel:=(2*pi/anz)*player;
x:=trunc(cos(winkel)*180)+300;
y:=trunc(sin(winkel)*180)+180;
putpicture(x,y,addr(knight));
outtextxy(x,y+55,z^.name);
setcolor(15);
if z=focus then rectangle(x,y,x+50,y+50);
player:=player+1;
z:=z^.next;
until z=ring;
delay(300);
end;

procedure tod(focus:zeiger);
var z:zeiger;
    player:byte;
    winkel:real;
    x,y:integer;
begin
loadpicture(addr(knight),'knight2.pic');
z:=ring;
player:=1;
textcolor(15);
repeat
player:=player+1;
z:=z^.next;
until z=focus;
winkel:=(2*pi/anz)*player;
x:=trunc(cos(winkel)*180)+300;
y:=trunc(sin(winkel)*180)+180;
putpicture(x,y,addr(knight));
end;


procedure lanze(spieler:zeiger);
begin
if random(spieler^.quote)+1=1 then
begin
outtextxy(200,450,'Ritter '+spieler^.name+' hat '+spieler^.next^.name+' gettet!');
tod(spieler^.next);
ring:=spieler;
ring^.next:=ring^.next^.next;
repeat until keypressed;
show(spieler);
end
else
begin
sound(100);
delay(200);
nosound;
if spieler^.quote>0 then spieler^.quote:=spieler^.quote+1;
end;
end;


procedure win;
begin
sound(100);
delay(250);
sound(150);
delay(250);
sound(200);
delay(250);
sound(250);
delay(250);
nosound;
delay(250);
sound(200);
delay(250);
sound(250);
delay(500);
nosound;
end;

procedure play;
var player:byte;
    winkel:real;
    focus:zeiger;
begin
focus:=ring;
clrscr;
repeat
focus:=focus^.next;
show(focus);
lanze(focus);
delay(500);
if keypressed and (readkey=chr(27)) then  exit;
until (focus^.next=focus);
win;
repeat until keypressed;
end;

procedure init;
var i:integer;
    z:zeiger;
    s:string;
begin
randomize;
gd:=detect;
initgraph(gd,gm,egavgaPath);
ec:=graphresult;
ring:=nil;
new(ring);
z:=ring;
z^.name:=namen[random(12)+1];
z^.quote:=random(10)+1;
z^.next:=nil;
new(z^.next);
for i:=2 to anzahl do
begin
z:=z^.next;
z^.name:=namen[random(12)+1];
z^.quote:=random(10)+1;
z^.next:=nil;
new(z^.next);
end;
z^.name:=namen[random(12)+1];
z^.quote:=random(10)+1;
z^.next:=nil;
new(z^.next);
z^.next:=ring;
end;

begin
init;
show(ring);
play;
nosound;
end.
